﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HabboTraxDEBESTE2
{
    public class Trax
    {
        public string Code;
        public double? length;
        public double Length
        {
            get
            {
                if (length.HasValue)
                    return length.Value;

                //Hack: if for some reason this trax hasn't been loaded by the player, we just 
                //create a player instance to try and get the length of the trax
                Player player = new Player();
                player.TraxNeeded = new Trax[1] { this };
                return this.length.Value;
            }
            set
            {
                length = value;
            }
        }
        public string CD
        {
            get;
            private set;
        }

        public int TraxNr
        {
            get;
            private set;
        }


        public Trax(string cd, int traxNr)
        {
            this.CD = cd;
            this.TraxNr = traxNr;
            Code = cd + "_" + traxNr;
        }

        public int GetTotalParts()
        {
            return (int)Math.Round(Length / 2);
        }

        public override bool Equals(object obj)
        {
            Trax trax = obj as Trax;
            if (trax != null)
                return trax.Code == this.Code;
            return base.Equals(obj);
        }
    }
}
